<!DOCTYPE html>
<html lang="en">

<head>

    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Load all orders - Danh sách đơn hàng</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body onload="onPageLoading()">
    <div class="container-fluid pt-4">
        <h2 class="text-center pb-3">Danh sách đơn hàng</h2>
        <button onclick="onBtnThemDonHangClick()" class="btn btn-primary">Thêm đơn hàng</button>
        <table class="table text-center table-striped" id="table-order">
            <thead>
                <tr>
                    <th scope="col">Order Code</th>
                    <th scope="col">Kích cỡ combo</th>
                    <th scope="col">Loại pizza</th>
                    <th scope="col">Nước uống</th>
                    <th scope="col">Thành tiền</th>
                    <th scope="col">Họ và tên</th>
                    <th scope="col">Số điện thoại</th>
                    <th scope="col">Trạng thái</th>
                    <th scope="col">Chi tiết</th>
                    <th scope="col">Delete</th>
                </tr>
            </thead>
            <tbody>

            </tbody>
        </table>
    </div>

    <script>
        "use strict";
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        const gEND_OF_ROW_COL = -1;
        const gREQUEST_STATUS_OK = 200;
        const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
        const vBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";
        const vDETAIL_FORM_URL = "orderDetail.html";
        const gREQUEST_DELETE_SUCCESS = 204;
        const vORDER_FORM_URL = "create.order.html";
        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */


        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        // Hàm thực hiện khi load trang
        function onPageLoading() {
            getAllOrders();
        }

        //hàm xử lý sự kiện bấm nút chi tiết
        function onBtnChiTietClick(paramChiTietClick) {
            var vId = paramChiTietClick.dataset.id;
            var vOrderCode = paramChiTietClick.dataset.ordercode;
            //ghi ra console
            console.log("ID: " + vId);
            console.log("Order code: " + vOrderCode);
            //thêm link trang detail vào nút
            var vUrl = vDETAIL_FORM_URL + "?" + "id=" + vId + "&orderCode=" + vOrderCode;
            window.location.href = vUrl;
        }

        //hàm xuwe lý sự kiện click nút Xóa
        function onBtnXoaClick(paramXoaClick) {
            var vConfirm = "Bạn có chắc chắn muốn xóa đơn hàng này không?"
            var vId = paramXoaClick.dataset.id;
            var vOrderCode = paramXoaClick.dataset.ordercode;
            //ghi ra console
            console.log("ID: " + vId);
            console.log("Order code: " + vOrderCode);
            if (confirm(vConfirm) == true) {
                //gọi API
                callAPIToDeleteOrder(vId);
            }
        }

        //Hàm xử lý khi click nút thêm đơn hàng
        function onBtnThemDonHangClick(){
            window.location.href = vORDER_FORM_URL;
        }

        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        //hàm gọi API Xóa đơn hàng theo id
        function callAPIToDeleteOrder(paramIDObj) {
            var vXmlHttpOrder = new XMLHttpRequest();
            vXmlHttpOrder.open("DELETE", vBASE_URL + "/" + paramIDObj, true);
            vXmlHttpOrder.send();
            vXmlHttpOrder.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK
                    && this.status == gREQUEST_DELETE_SUCCESS) {
                    console.log("Delete order " + paramIDObj + " thành công!");
                    var vResponseText = JSON.parse(vXmlHttpOrder.readyState);
                    console.log(vResponseText);
                    if(vResponseText = 4){
                        alert("Order đã được xóa");
                    }
                    else{
                        alert("Yêu cầu xóa không thành công");
                    }
                }
            }
        }

        // Hàm thực hiện việc load all orders từ server và load vào table
        function getAllOrders() {
            /**
           * Chia để trị - 04 bước cố gắng thành 04 functions riêng biệt
           */
            // B1: Thu thập dữ liệu (trong bài này bước này ko cần)
            // B2: Validate dữ liệu (trong bài này bước này ko cần)
            // B3: Thực hiện việc gọi API từ server Server
            var vXmlHttpGetAllOrders = new XMLHttpRequest();
            callApiToGetAllOrders(vXmlHttpGetAllOrders);

            // B4: Xử lý trên front-end khi request xử lý xong và trả về response thành công
            vXmlHttpGetAllOrders.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    loadOrderToTable(vXmlHttpGetAllOrders);
                }
            }
        }

        // hàm gọi api để lấy all orders
        function callApiToGetAllOrders(paramXMLHttpGetAllOrders) {
            const vBaseUrl = "http://203.171.20.210:8080/devcamp-pizza365/orders";
            paramXMLHttpGetAllOrders.open("GET", vBaseUrl, true);
            paramXMLHttpGetAllOrders.send();
        }

        // input: xml http request đã đươc trả lời
        // ouptut/end: dữ liệu hiên thi trên bảng
        function loadOrderToTable(paramXMLHttpAllOrder) {
            //CODE Ở ĐÂY ĐỂ LOAD DATA VÀO TABLE
            var vResponseText = paramXMLHttpAllOrder.responseText;
            //ghi ra console
            // console.log(vResponseText);
            //chuyển đổi JSON
            var vResponse = JSON.parse(vResponseText);
            var vTable = document.getElementById("table-order");
            var vTableTBody = vTable.getElementsByTagName("tbody")[0];
            //thêm row mới vào bảng
            for (var bI = 0; bI < vResponse.length; bI++) {
                var bNewOrderRow = vTableTBody.insertRow(gEND_OF_ROW_COL);
                //thêm cell
                var bOrderCodecell = bNewOrderRow.insertCell(0);
                var bComboSizeCell = bNewOrderRow.insertCell(1);
                var bPizzaTypeCell = bNewOrderRow.insertCell(2);
                var bDrinkCell = bNewOrderRow.insertCell(3);
                var bThanhTienCell = bNewOrderRow.insertCell(4);
                var bHoVaTenCell = bNewOrderRow.insertCell(5);
                var bPhoneNumberCell = bNewOrderRow.insertCell(6);
                var bStatusCell = bNewOrderRow.insertCell(7);
                var bActionCell = bNewOrderRow.insertCell(8);
                var bDeleteCell = bNewOrderRow.insertCell(9);
                //thêm dũ liệu vào cell
                bOrderCodecell.innerHTML = vResponse[bI].orderCode;
                bComboSizeCell.innerHTML = vResponse[bI].kichCo;
                bPizzaTypeCell.innerHTML = vResponse[bI].loaiPizza;
                bDrinkCell.innerHTML = vResponse[bI].idLoaiNuocUong;
                bThanhTienCell.innerHTML = vResponse[bI].thanhTien;
                bHoVaTenCell.innerHTML = vResponse[bI].hoTen;
                bPhoneNumberCell.innerHTML = vResponse[bI].soDienThoai;
                bStatusCell.innerHTML = vResponse[bI].trangThai;
                //Nút chi tiết
                var bButton = document.createElement("button");
                bButton.textContent = "Chi Tiết";
                bButton.className = "btn btn-primary";
                bButton.setAttribute("data-id", vResponse[bI].id);
                bButton.setAttribute("data-ordercode", vResponse[bI].orderCode);
                bActionCell.appendChild(bButton);
                //thêm sự kiện vào nút
                bButton.addEventListener("click", function () {
                    onBtnChiTietClick(this);
                });
                //thêm nút delete
                var bButton1 = document.createElement("button");
                bButton1.textContent = "Xóa";
                bButton1.className = "btn btn-danger";
                bButton1.setAttribute("data-id", vResponse[bI].id);
                bButton1.setAttribute("data-ordercode", vResponse[bI].orderCode);
                bDeleteCell.appendChild(bButton1);
                //them sự kiện vào nút xóa
                bButton1.addEventListener("click", function () {
                    onBtnXoaClick(this);
                });
            }
        }

    </script>
</body>

</html>